<?php

namespace Chronopost;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'resultGetReservedSkybillValue' => '\\Chronopost\\StructType\\ResultGetReservedSkybillValue',
            'resultReservationExpeditionValue' => '\\Chronopost\\StructType\\ResultReservationExpeditionValue',
            'esdValue' => '\\Chronopost\\StructType\\EsdValue',
            'headerValue' => '\\Chronopost\\StructType\\HeaderValue',
            'shipperValue' => '\\Chronopost\\StructType\\ShipperValue',
            'customerValue' => '\\Chronopost\\StructType\\CustomerValue',
            'recipientValue' => '\\Chronopost\\StructType\\RecipientValue',
            'refValue' => '\\Chronopost\\StructType\\RefValue',
            'skybillValue' => '\\Chronopost\\StructType\\SkybillValue',
            'skybillParamsValue' => '\\Chronopost\\StructType\\SkybillParamsValue',
            'scheduledValue' => '\\Chronopost\\StructType\\ScheduledValue',
            'appointmentValue' => '\\Chronopost\\StructType\\AppointmentValue',
            'resultExpeditionValue' => '\\Chronopost\\StructType\\ResultExpeditionValue',
            'esdWithRefClientValue' => '\\Chronopost\\StructType\\EsdWithRefClientValue',
            'esdWithRefClientValueV2' => '\\Chronopost\\StructType\\EsdWithRefClientValueV2',
            'esdValue3' => '\\Chronopost\\StructType\\EsdValue3',
            'headerValueV2' => '\\Chronopost\\StructType\\HeaderValueV2',
            'shipperValueV2' => '\\Chronopost\\StructType\\ShipperValueV2',
            'recipientValueV2' => '\\Chronopost\\StructType\\RecipientValueV2',
            'refValueV2' => '\\Chronopost\\StructType\\RefValueV2',
            'skybillWithDimensionsValue' => '\\Chronopost\\StructType\\SkybillWithDimensionsValue',
            'skybillWithDimensionsValueV2' => '\\Chronopost\\StructType\\SkybillWithDimensionsValueV2',
            'skybillWithDimensionsValueV3' => '\\Chronopost\\StructType\\SkybillWithDimensionsValueV3',
            'skybillWithDimensionsValueV4' => '\\Chronopost\\StructType\\SkybillWithDimensionsValueV4',
            'skybillWithDimensionsValueV5' => '\\Chronopost\\StructType\\SkybillWithDimensionsValueV5',
            'skybillWithDimensionsValueV6' => '\\Chronopost\\StructType\\SkybillWithDimensionsValueV6',
            'skybillWithDimensionsValueV7' => '\\Chronopost\\StructType\\SkybillWithDimensionsValueV7',
            'skybillParamsValueV2' => '\\Chronopost\\StructType\\SkybillParamsValueV2',
            'recipientLocalValue' => '\\Chronopost\\StructType\\RecipientLocalValue',
            'recipientLocalValueV2' => '\\Chronopost\\StructType\\RecipientLocalValueV2',
            'customsValue' => '\\Chronopost\\StructType\\CustomsValue',
            'articleValue' => '\\Chronopost\\StructType\\ArticleValue',
            'resultShippingValue' => '\\Chronopost\\StructType\\ResultShippingValue',
            'resultMultiParcelExpeditionValue' => '\\Chronopost\\StructType\\ResultMultiParcelExpeditionValue',
            'resultMultiParcelValue' => '\\Chronopost\\StructType\\ResultMultiParcelValue',
            'resultExpeditionValueV3' => '\\Chronopost\\StructType\\ResultExpeditionValueV3',
            'resultMonoParcelExpeditionValue' => '\\Chronopost\\StructType\\ResultMonoParcelExpeditionValue',
            'resultGetRouting' => '\\Chronopost\\StructType\\ResultGetRouting',
            'geopostResult' => '\\Chronopost\\StructType\\GeopostResult',
            'skybillValueV2' => '\\Chronopost\\StructType\\SkybillValueV2',
            'resultFaisabiliteESD' => '\\Chronopost\\StructType\\ResultFaisabiliteESD',
            'donneurDOrdre' => '\\Chronopost\\StructType\\DonneurDOrdre',
            'adresseEnlevement' => '\\Chronopost\\StructType\\AdresseEnlevement',
            'adresseEnlevementV2' => '\\Chronopost\\StructType\\AdresseEnlevementV2',
            'adresseEnlevementV3' => '\\Chronopost\\StructType\\AdresseEnlevementV3',
            'particularitesEsd' => '\\Chronopost\\StructType\\ParticularitesEsd',
            'options' => '\\Chronopost\\StructType\\Options',
            'resultEnlevementNational' => '\\Chronopost\\StructType\\ResultEnlevementNational',
            'infoEnlevement' => '\\Chronopost\\StructType\\InfoEnlevement',
            'resultGetReservedSkybillWithTypeValue' => '\\Chronopost\\StructType\\ResultGetReservedSkybillWithTypeValue',
            'destinatairesDpd' => '\\Chronopost\\StructType\\DestinatairesDpd',
            'destinataireDpd' => '\\Chronopost\\StructType\\DestinataireDpd',
            'adresseDestinataire' => '\\Chronopost\\StructType\\AdresseDestinataire',
            'infoClient' => '\\Chronopost\\StructType\\InfoClient',
            'particularites' => '\\Chronopost\\StructType\\Particularites',
            'particularitesColisDpd' => '\\Chronopost\\StructType\\ParticularitesColisDpd',
            'infoDouanieres' => '\\Chronopost\\StructType\\InfoDouanieres',
            'resultPickupOrCollectionRequest' => '\\Chronopost\\StructType\\ResultPickupOrCollectionRequest',
            'resultReservationMultiParcelExpeditionValue' => '\\Chronopost\\StructType\\ResultReservationMultiParcelExpeditionValue',
            'resultParcelValue' => '\\Chronopost\\StructType\\ResultParcelValue',
            'esdResultContraintesAgenceValue' => '\\Chronopost\\StructType\\EsdResultContraintesAgenceValue',
            'esdContraintesAgence' => '\\Chronopost\\StructType\\EsdContraintesAgence',
            'resultReservationMultiParcelExpeditionValueV2' => '\\Chronopost\\StructType\\ResultReservationMultiParcelExpeditionValueV2',
            'resultAnnulerEnlevement' => '\\Chronopost\\StructType\\ResultAnnulerEnlevement',
            'statut' => '\\Chronopost\\StructType\\Statut',
            'entry' => '\\Chronopost\\StructType\\Entry',
            'resultReservationExpeditionValueV2' => '\\Chronopost\\StructType\\ResultReservationExpeditionValueV2',
            'skybillValueBase' => '\\Chronopost\\StructType\\SkybillValueBase',
            'resultShippingInfo' => '\\Chronopost\\StructType\\ResultShippingInfo',
            'error' => '\\Chronopost\\StructType\\Error',
            'detail' => '\\Chronopost\\StructType\\Detail',
            'shippingInfo' => '\\Chronopost\\StructType\\ShippingInfo',
            'getReservedSkybill' => '\\Chronopost\\StructType\\GetReservedSkybill',
            'getReservedSkybillResponse' => '\\Chronopost\\StructType\\GetReservedSkybillResponse',
            'shippingWithReservationAndESDWithRefClientPC' => '\\Chronopost\\StructType\\ShippingWithReservationAndESDWithRefClientPC',
            'shippingWithReservationAndESDWithRefClientPCResponse' => '\\Chronopost\\StructType\\ShippingWithReservationAndESDWithRefClientPCResponse',
            'shippingV3' => '\\Chronopost\\StructType\\ShippingV3',
            'shippingV3Response' => '\\Chronopost\\StructType\\ShippingV3Response',
            'shippingV2' => '\\Chronopost\\StructType\\ShippingV2',
            'shippingV2Response' => '\\Chronopost\\StructType\\ShippingV2Response',
            'shippingWithESDOnlyV2' => '\\Chronopost\\StructType\\ShippingWithESDOnlyV2',
            'shippingWithESDOnlyV2Response' => '\\Chronopost\\StructType\\ShippingWithESDOnlyV2Response',
            'shippingMultiParcelV6' => '\\Chronopost\\StructType\\ShippingMultiParcelV6',
            'shippingMultiParcelV6Response' => '\\Chronopost\\StructType\\ShippingMultiParcelV6Response',
            'shippingMultiParcelV5' => '\\Chronopost\\StructType\\ShippingMultiParcelV5',
            'shippingMultiParcelV5Response' => '\\Chronopost\\StructType\\ShippingMultiParcelV5Response',
            'shippingV7' => '\\Chronopost\\StructType\\ShippingV7',
            'shippingV7Response' => '\\Chronopost\\StructType\\ShippingV7Response',
            'getRouting' => '\\Chronopost\\StructType\\GetRouting',
            'getRoutingResponse' => '\\Chronopost\\StructType\\GetRoutingResponse',
            'shippingMultiParcelV4' => '\\Chronopost\\StructType\\ShippingMultiParcelV4',
            'shippingMultiParcelV4Response' => '\\Chronopost\\StructType\\ShippingMultiParcelV4Response',
            'shippingV6' => '\\Chronopost\\StructType\\ShippingV6',
            'shippingV6Response' => '\\Chronopost\\StructType\\ShippingV6Response',
            'shippingMultiParcelV3' => '\\Chronopost\\StructType\\ShippingMultiParcelV3',
            'shippingMultiParcelV3Response' => '\\Chronopost\\StructType\\ShippingMultiParcelV3Response',
            'shippingV5' => '\\Chronopost\\StructType\\ShippingV5',
            'shippingV5Response' => '\\Chronopost\\StructType\\ShippingV5Response',
            'shippingMultiParcelV2' => '\\Chronopost\\StructType\\ShippingMultiParcelV2',
            'shippingMultiParcelV2Response' => '\\Chronopost\\StructType\\ShippingMultiParcelV2Response',
            'shippingV4' => '\\Chronopost\\StructType\\ShippingV4',
            'shippingV4Response' => '\\Chronopost\\StructType\\ShippingV4Response',
            'faisabiliteESD' => '\\Chronopost\\StructType\\FaisabiliteESD',
            'faisabiliteESDResponse' => '\\Chronopost\\StructType\\FaisabiliteESDResponse',
            'creerEnlevementNational' => '\\Chronopost\\StructType\\CreerEnlevementNational',
            'creerEnlevementNationalResponse' => '\\Chronopost\\StructType\\CreerEnlevementNationalResponse',
            'shippingWithESDOnly' => '\\Chronopost\\StructType\\ShippingWithESDOnly',
            'shippingWithESDOnlyResponse' => '\\Chronopost\\StructType\\ShippingWithESDOnlyResponse',
            'getReservedSkybillWithTypeAndModeByReservation' => '\\Chronopost\\StructType\\GetReservedSkybillWithTypeAndModeByReservation',
            'getReservedSkybillWithTypeAndModeByReservationResponse' => '\\Chronopost\\StructType\\GetReservedSkybillWithTypeAndModeByReservationResponse',
            'creerEnlevementEurope' => '\\Chronopost\\StructType\\CreerEnlevementEurope',
            'creerEnlevementEuropeResponse' => '\\Chronopost\\StructType\\CreerEnlevementEuropeResponse',
            'shippingMultiParcelWithReservation' => '\\Chronopost\\StructType\\ShippingMultiParcelWithReservation',
            'shippingMultiParcelWithReservationResponse' => '\\Chronopost\\StructType\\ShippingMultiParcelWithReservationResponse',
            'rechercherContraintesEnlevement' => '\\Chronopost\\StructType\\RechercherContraintesEnlevement',
            'rechercherContraintesEnlevementResponse' => '\\Chronopost\\StructType\\RechercherContraintesEnlevementResponse',
            'shippingWithReservationAndESDWithRefClient' => '\\Chronopost\\StructType\\ShippingWithReservationAndESDWithRefClient',
            'shippingWithReservationAndESDWithRefClientResponse' => '\\Chronopost\\StructType\\ShippingWithReservationAndESDWithRefClientResponse',
            'shippingMultiParcel' => '\\Chronopost\\StructType\\ShippingMultiParcel',
            'shippingMultiParcelResponse' => '\\Chronopost\\StructType\\ShippingMultiParcelResponse',
            'getSkybill' => '\\Chronopost\\StructType\\GetSkybill',
            'getSkybillResponse' => '\\Chronopost\\StructType\\GetSkybillResponse',
            'getReservedSkybillWithTypeAndModeAuth' => '\\Chronopost\\StructType\\GetReservedSkybillWithTypeAndModeAuth',
            'getReservedSkybillWithTypeAndModeAuthResponse' => '\\Chronopost\\StructType\\GetReservedSkybillWithTypeAndModeAuthResponse',
            'shipping' => '\\Chronopost\\StructType\\Shipping',
            'shippingResponse' => '\\Chronopost\\StructType\\ShippingResponse',
            'getReservedSkybillWithTypeAndMode' => '\\Chronopost\\StructType\\GetReservedSkybillWithTypeAndMode',
            'getReservedSkybillWithTypeAndModeResponse' => '\\Chronopost\\StructType\\GetReservedSkybillWithTypeAndModeResponse',
            'getReservedSkybillWithType' => '\\Chronopost\\StructType\\GetReservedSkybillWithType',
            'getReservedSkybillWithTypeResponse' => '\\Chronopost\\StructType\\GetReservedSkybillWithTypeResponse',
            'shippingMultiParcelWithReservationV3' => '\\Chronopost\\StructType\\ShippingMultiParcelWithReservationV3',
            'shippingMultiParcelWithReservationV3Response' => '\\Chronopost\\StructType\\ShippingMultiParcelWithReservationV3Response',
            'annulerEnlevements' => '\\Chronopost\\StructType\\AnnulerEnlevements',
            'annulerEnlevementsResponse' => '\\Chronopost\\StructType\\AnnulerEnlevementsResponse',
            'shippingMultiParcelWithReservationV2' => '\\Chronopost\\StructType\\ShippingMultiParcelWithReservationV2',
            'shippingMultiParcelWithReservationV2Response' => '\\Chronopost\\StructType\\ShippingMultiParcelWithReservationV2Response',
            'shippingWithReservationV2' => '\\Chronopost\\StructType\\ShippingWithReservationV2',
            'shippingWithReservationV2Response' => '\\Chronopost\\StructType\\ShippingWithReservationV2Response',
            'getShippingInformation' => '\\Chronopost\\StructType\\GetShippingInformation',
            'getShippingInformationResponse' => '\\Chronopost\\StructType\\GetShippingInformationResponse',
            'shippingWithReservation' => '\\Chronopost\\StructType\\ShippingWithReservation',
            'shippingWithReservationResponse' => '\\Chronopost\\StructType\\ShippingWithReservationResponse',
        );
    }
}
